diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_exten.c openssl-1.0.0q/crypto/asn1/x_exten.c
--- openssl-1.0.0q.orig/crypto/asn1/x_exten.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_exten.c	2017-04-25 16:23:40.016528354 +0200
@@ -56,18 +56,23 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(X509_EXTENSION) = {
-	ASN1_SIMPLE(X509_EXTENSION, object, ASN1_OBJECT),
-	ASN1_OPT(X509_EXTENSION, critical, ASN1_BOOLEAN),
+ASN1_SEQUENCE(X509_EXTENSION)
+	ASN1_SIMPLE(X509_EXTENSION, object, ASN1_OBJECT)
+	ASN1_OPT(X509_EXTENSION, critical, ASN1_BOOLEAN)
 	ASN1_SIMPLE(X509_EXTENSION, value, ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END(X509_EXTENSION)
+ASN1_SEQUENCE_END(X509_EXTENSION)
 
-ASN1_ITEM_TEMPLATE(X509_EXTENSIONS) = 
+ASN1_ITEM_TEMPLATE(X509_EXTENSIONS)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, Extension, X509_EXTENSION)
 ASN1_ITEM_TEMPLATE_END(X509_EXTENSIONS)
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_info.c openssl-1.0.0q/crypto/asn1/x_info.c
--- openssl-1.0.0q.orig/crypto/asn1/x_info.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_info.c	2017-04-25 16:23:40.017525967 +0200
@@ -56,12 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/asn1.h>
 #include <openssl/x509.h>
 
+#ifndef OPERA_SMALL_VERSION
 X509_INFO *X509_INFO_new(void)
 	{
 	X509_INFO *ret=NULL;
@@ -111,4 +114,5 @@
 	}
 
 IMPLEMENT_STACK_OF(X509_INFO)
+#endif // !OPERA_SMALL_VERSION
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_long.c openssl-1.0.0q/crypto/asn1/x_long.c
--- openssl-1.0.0q.orig/crypto/asn1/x_long.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_long.c	2017-04-25 16:23:40.018525815 +0200
@@ -56,10 +56,13 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/bn.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Custom primitive type for long handling. This converts between an ASN1_INTEGER
  * and a long directly.
@@ -73,23 +76,22 @@
 static int long_c2i(ASN1_VALUE **pval, const unsigned char *cont, int len, int utype, char *free_cont, const ASN1_ITEM *it);
 static int long_print(BIO *out, ASN1_VALUE **pval, const ASN1_ITEM *it, int indent, const ASN1_PCTX *pctx);
 
-static ASN1_PRIMITIVE_FUNCS long_pf = {
-	NULL, 0,
-	long_new,
-	long_free,
-	long_free,	/* Clear should set to initial value */
-	long_c2i,
-	long_i2c,
-	long_print
-};
-
-ASN1_ITEM_start(LONG)
-	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &long_pf, ASN1_LONG_UNDEF, "LONG"
-ASN1_ITEM_end(LONG)
-
-ASN1_ITEM_start(ZLONG)
-	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &long_pf, 0, "ZLONG"
-ASN1_ITEM_end(ZLONG)
+OPENSSL_PREFIX_CONST_ITEM(static, ASN1_PRIMITIVE_FUNCS, long_pf, libopeay)
+	CONST_ITEM_ENTRY_START(app_data, NULL)
+	CONST_ITEM_ENTRY_SINGLE(flags, 0)
+	CONST_ITEM_ENTRY_SINGLE(prim_new, long_new)
+	CONST_ITEM_ENTRY_SINGLE(prim_free, long_free)
+	CONST_ITEM_ENTRY_SINGLE(prim_clear, long_free)	/* Clear should set to initial value */
+	CONST_ITEM_ENTRY_SINGLE(prim_c2i, long_c2i)
+	CONST_ITEM_ENTRY_SINGLE(prim_i2c, long_i2c)
+	CONST_ITEM_ENTRY_SINGLE(prim_print, long_print)
+CONST_ITEM_ENTRY_END
+
+ASN1_ITEM_TEMPLATE_BLOCK(LONG,
+	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &OPENSSL_GLOBAL_ITEM_NAME(long_pf), ASN1_LONG_UNDEF)
+
+ASN1_ITEM_TEMPLATE_BLOCK(ZLONG,
+	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &OPENSSL_GLOBAL_ITEM_NAME(long_pf), 0)
 
 static int long_new(ASN1_VALUE **pval, const ASN1_ITEM *it)
 {
@@ -111,7 +113,7 @@
 	char *cp = (char *)pval;
 
 	/* use memcpy, because we may not be long aligned */
-	memcpy(&ltmp, cp, sizeof(long));
+	op_memcpy(&ltmp, cp, sizeof(long));
 
 	if(ltmp == it->size) return -1;
 	/* Convert the long to positive: we subtract one if negative so
@@ -168,7 +170,7 @@
 		ASN1err(ASN1_F_LONG_C2I, ASN1_R_INTEGER_TOO_LARGE_FOR_LONG);
 		return 0;
 	}
-	memcpy(cp, &ltmp, sizeof(long));
+	op_memcpy(cp, &ltmp, sizeof(long));
 	return 1;
 }
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_name.c openssl-1.0.0q/crypto/asn1/x_name.c
--- openssl-1.0.0q.orig/crypto/asn1/x_name.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_name.c	2017-04-25 16:23:40.019525663 +0200
@@ -56,12 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include "asn1_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
 
 typedef STACK_OF(X509_NAME_ENTRY) STACK_OF_X509_NAME_ENTRY;
 DECLARE_STACK_OF(STACK_OF_X509_NAME_ENTRY)
@@ -88,23 +91,23 @@
 						const char *fname, 
 						const ASN1_PCTX *pctx);
 
-ASN1_SEQUENCE(X509_NAME_ENTRY) = {
-	ASN1_SIMPLE(X509_NAME_ENTRY, object, ASN1_OBJECT),
+ASN1_SEQUENCE(X509_NAME_ENTRY)
+	ASN1_SIMPLE(X509_NAME_ENTRY, object, ASN1_OBJECT)
 	ASN1_SIMPLE(X509_NAME_ENTRY, value, ASN1_PRINTABLE)
-} ASN1_SEQUENCE_END(X509_NAME_ENTRY)
+ASN1_SEQUENCE_END(X509_NAME_ENTRY)
 
-IMPLEMENT_ASN1_FUNCTIONS(X509_NAME_ENTRY)
+IMPLEMENT_ASN1_FUNCTIONS3(X509_NAME_ENTRY)
 IMPLEMENT_ASN1_DUP_FUNCTION(X509_NAME_ENTRY)
 
 /* For the "Name" type we need a SEQUENCE OF { SET OF X509_NAME_ENTRY }
  * so declare two template wrappers for this
  */
 
-ASN1_ITEM_TEMPLATE(X509_NAME_ENTRIES) =
+ASN1_ITEM_TEMPLATE(X509_NAME_ENTRIES)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SET_OF, 0, RDNS, X509_NAME_ENTRY)
 ASN1_ITEM_TEMPLATE_END(X509_NAME_ENTRIES)
 
-ASN1_ITEM_TEMPLATE(X509_NAME_INTERNAL) =
+ASN1_ITEM_TEMPLATE(X509_NAME_INTERNAL)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, Name, X509_NAME_ENTRIES)
 ASN1_ITEM_TEMPLATE_END(X509_NAME_INTERNAL)
 
@@ -114,17 +117,17 @@
  * to the external form.
  */
 
-const ASN1_EXTERN_FUNCS x509_name_ff = {
-	NULL,
-	x509_name_ex_new,
-	x509_name_ex_free,
-	0,	/* Default clear behaviour is OK */
-	x509_name_ex_d2i,
-	x509_name_ex_i2d,
-	x509_name_ex_print
-};
+OPENSSL_PREFIX_CONST_ITEM(static, ASN1_EXTERN_FUNCS, x509_name_ff, libopeay)
+	CONST_ITEM_ENTRY_START(app_data, NULL)
+	CONST_ITEM_ENTRY_SINGLE(asn1_ex_new,x509_name_ex_new)
+	CONST_ITEM_ENTRY_SINGLE(asn1_ex_free,x509_name_ex_free)
+	CONST_ITEM_ENTRY_SINGLE(asn1_ex_clear,0)	/* Default clear behaviour is OK */
+	CONST_ITEM_ENTRY_SINGLE(asn1_ex_d2i,x509_name_ex_d2i)
+	CONST_ITEM_ENTRY_SINGLE(asn1_ex_i2d,x509_name_ex_i2d)
+	CONST_ITEM_ENTRY_SINGLE(asn1_ex_print,x509_name_ex_print)
+CONST_ITEM_ENTRY_END
 
-IMPLEMENT_EXTERN_ASN1(X509_NAME, V_ASN1_SEQUENCE, x509_name_ff) 
+IMPLEMENT_EXTERN_ASN1(X509_NAME, V_ASN1_SEQUENCE, OPENSSL_GLOBAL_ITEM_NAME(x509_name_ff))
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_NAME)
 IMPLEMENT_ASN1_DUP_FUNCTION(X509_NAME)
@@ -132,7 +135,7 @@
 static int x509_name_ex_new(ASN1_VALUE **val, const ASN1_ITEM *it)
 {
 	X509_NAME *ret = NULL;
-	ret = OPENSSL_malloc(sizeof(X509_NAME));
+	ret = (X509_NAME *) OPENSSL_malloc(sizeof(X509_NAME));
 	if(!ret) goto memerr;
 	if ((ret->entries=sk_X509_NAME_ENTRY_new_null()) == NULL)
 		goto memerr;
@@ -193,7 +196,7 @@
 	if(!x509_name_ex_new(&nm.a, NULL)) goto err;
 	/* We've decoded it: now cache encoding */
 	if(!BUF_MEM_grow(nm.x->bytes, p - q)) goto err;
-	memcpy(nm.x->bytes->data, q, p - q);
+	op_memcpy(nm.x->bytes->data, q, p - q);
 
 	/* Convert internal representation to X509_NAME structure */
 	for(i = 0; i < sk_STACK_OF_X509_NAME_ENTRY_num(intname.s); i++) {
@@ -235,7 +238,7 @@
 	}
 	ret = a->bytes->length;
 	if(out != NULL) {
-		memcpy(*out,a->bytes->data,ret);
+		op_memcpy(*out,a->bytes->data,ret);
 		*out+=ret;
 	}
 	return ret;
@@ -362,7 +365,7 @@
 
 	a->canon_enclen = i2d_name_canon(intname, NULL);
 
-	p = OPENSSL_malloc(a->canon_enclen);
+	p = (unsigned char *) OPENSSL_malloc(a->canon_enclen);
 
 	if (!p)
 		goto err;
@@ -421,7 +424,7 @@
 	 */
 
 	/* Ignore leading spaces */
-	while((len > 0) && !(*from & 0x80) && isspace(*from))
+	while((len > 0) && !(*from & 0x80) && op_isspace(*from))
 		{
 		from++;
 		len--;
@@ -430,7 +433,7 @@
 	to = from + len - 1;
 
 	/* Ignore trailing spaces */
-	while ((len > 0) && !(*to & 0x80) && isspace(*to))
+	while ((len > 0) && !(*to & 0x80) && op_isspace(*to))
 		{
 		to--;
 		len--;
@@ -448,7 +451,7 @@
 			i++;
 			}
 		/* Collapse multiple spaces */
-		else if (isspace(*from))
+		else if (op_isspace(*from))
 			{
 			/* Copy one space across */
 			*to++ = ' ';
@@ -461,7 +464,7 @@
 				from++;
 				i++;
 				}
-			while(!(*from & 0x80) && isspace(*from));
+			while(!(*from & 0x80) && op_isspace(*from));
 			}
 		else
 			{
@@ -497,6 +500,7 @@
 	return len;
 	}
 
+#if !defined OPERA_SMALL_VERSION
 int X509_NAME_set(X509_NAME **xn, X509_NAME *name)
 	{
 	X509_NAME *in;
@@ -514,6 +518,7 @@
 		}
 	return(*xn != NULL);
 	}
+#endif
 	
 IMPLEMENT_STACK_OF(X509_NAME_ENTRY)
 IMPLEMENT_ASN1_SET_OF(X509_NAME_ENTRY)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_pkey.c openssl-1.0.0q/crypto/asn1/x_pkey.c
--- openssl-1.0.0q.orig/crypto/asn1/x_pkey.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_pkey.c	2017-04-25 16:23:40.020525510 +0200
@@ -56,13 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/asn1_mac.h>
 #include <openssl/x509.h>
 
+#ifndef OPERA_SMALL_VERSION
 /* need to implement */
 int i2d_X509_PKEY(X509_PKEY *a, unsigned char **pp)
 	{
@@ -96,11 +99,11 @@
 			c.line=__LINE__;
 			goto err;
 			}
-		memcpy(ret->cipher.iv,
+		op_memcpy(ret->cipher.iv,
 			ret->enc_algor->parameter->value.octet_string->data,i);
 		}
 	else
-		memset(ret->cipher.iv,0,EVP_MAX_IV_LENGTH);
+		op_memset(ret->cipher.iv,0,EVP_MAX_IV_LENGTH);
 	M_ASN1_D2I_Finish(a,X509_PKEY_free,ASN1_F_D2I_X509_PKEY);
 	}
 
@@ -118,7 +121,7 @@
 	ret->key_data=NULL;
 	ret->key_free=0;
 	ret->cipher.cipher=NULL;
-	memset(ret->cipher.iv,0,EVP_MAX_IV_LENGTH);
+	op_memset(ret->cipher.iv,0,EVP_MAX_IV_LENGTH);
 	ret->references=1;
 	return(ret);
 	M_ASN1_New_Error(ASN1_F_X509_PKEY_NEW);
@@ -149,3 +152,4 @@
 	if ((x->key_data != NULL) && (x->key_free)) OPENSSL_free(x->key_data);
 	OPENSSL_free(x);
 	}
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_pubkey.c openssl-1.0.0q/crypto/asn1/x_pubkey.c
--- openssl-1.0.0q.orig/crypto/asn1/x_pubkey.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_pubkey.c	2017-04-25 16:23:40.021527034 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include "asn1_locl.h"
@@ -67,6 +69,7 @@
 #ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Minor tweak to operation: free up EVP_PKEY */
 static int pubkey_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
@@ -80,13 +83,14 @@
 	return 1;
 	}
 
-ASN1_SEQUENCE_cb(X509_PUBKEY, pubkey_cb) = {
-	ASN1_SIMPLE(X509_PUBKEY, algor, X509_ALGOR),
+ASN1_SEQUENCE_cb(X509_PUBKEY, pubkey_cb)
+	ASN1_SIMPLE(X509_PUBKEY, algor, X509_ALGOR)
 	ASN1_SIMPLE(X509_PUBKEY, public_key, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END_cb(X509_PUBKEY, X509_PUBKEY)
+ASN1_SEQUENCE_END_cb(X509_PUBKEY, X509_PUBKEY)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_PUBKEY)
 
+#if !defined(OPERA_SMALL_VERSION)
 int X509_PUBKEY_set(X509_PUBKEY **x, EVP_PKEY *pkey)
 	{
 	X509_PUBKEY *pk=NULL;
@@ -129,6 +133,7 @@
 	if (pk != NULL) X509_PUBKEY_free(pk);
 	return 0;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 EVP_PKEY *X509_PUBKEY_get(X509_PUBKEY *key)
 	{
@@ -194,6 +199,7 @@
 	return(NULL);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 /* Now two pseudo ASN1 routines that take an EVP_PKEY structure
  * and encode or decode as X509_PUBKEY
  */
@@ -347,6 +353,7 @@
 	return(ret);
 	}
 #endif
+#endif // !OPERA_SMALL_VERSION
 
 int X509_PUBKEY_set0_param(X509_PUBKEY *pub, ASN1_OBJECT *aobj,
 					int ptype, void *pval,
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_req.c openssl-1.0.0q/crypto/asn1/x_req.c
--- openssl-1.0.0q.orig/crypto/asn1/x_req.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_req.c	2017-04-25 16:23:40.022526603 +0200
@@ -56,10 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* X509_REQ_INFO is handled in an unusual way to get round
  * invalid encodings. Some broken certificate requests don't
@@ -91,23 +95,29 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_enc(X509_REQ_INFO, enc, rinf_cb) = {
-	ASN1_SIMPLE(X509_REQ_INFO, version, ASN1_INTEGER),
-	ASN1_SIMPLE(X509_REQ_INFO, subject, X509_NAME),
-	ASN1_SIMPLE(X509_REQ_INFO, pubkey, X509_PUBKEY),
+ASN1_SEQUENCE_enc(X509_REQ_INFO, enc, rinf_cb)
+	ASN1_SIMPLE(X509_REQ_INFO, version, ASN1_INTEGER)
+	ASN1_SIMPLE(X509_REQ_INFO, subject, X509_NAME)
+	ASN1_SIMPLE(X509_REQ_INFO, pubkey, X509_PUBKEY)
 	/* This isn't really OPTIONAL but it gets round invalid
 	 * encodings
 	 */
 	ASN1_IMP_SET_OF_OPT(X509_REQ_INFO, attributes, X509_ATTRIBUTE, 0)
-} ASN1_SEQUENCE_END_enc(X509_REQ_INFO, X509_REQ_INFO)
+ASN1_SEQUENCE_END_enc(X509_REQ_INFO, X509_REQ_INFO)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(X509_REQ_INFO)
+#endif
 
-ASN1_SEQUENCE_ref(X509_REQ, 0, CRYPTO_LOCK_X509_REQ) = {
-	ASN1_SIMPLE(X509_REQ, req_info, X509_REQ_INFO),
-	ASN1_SIMPLE(X509_REQ, sig_alg, X509_ALGOR),
+ASN1_SEQUENCE_ref(X509_REQ, 0, CRYPTO_LOCK_X509_REQ)
+	ASN1_SIMPLE(X509_REQ, req_info, X509_REQ_INFO)
+	ASN1_SIMPLE(X509_REQ, sig_alg, X509_ALGOR)
 	ASN1_SIMPLE(X509_REQ, signature, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END_ref(X509_REQ, X509_REQ)
+ ASN1_SEQUENCE_END_ref(X509_REQ, X509_REQ)
 
-IMPLEMENT_ASN1_FUNCTIONS(X509_REQ)
+IMPLEMENT_ASN1_FUNCTIONS1(X509_REQ)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_DUP_FUNCTION(X509_REQ)
+#endif
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_sig.c openssl-1.0.0q/crypto/asn1/x_sig.c
--- openssl-1.0.0q.orig/crypto/asn1/x_sig.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_sig.c	2017-04-25 16:23:40.022526603 +0200
@@ -56,14 +56,17 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(X509_SIG) = {
-	ASN1_SIMPLE(X509_SIG, algor, X509_ALGOR),
+ASN1_SEQUENCE(X509_SIG)
+	ASN1_SIMPLE(X509_SIG, algor, X509_ALGOR)
 	ASN1_SIMPLE(X509_SIG, digest, ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END(X509_SIG)
+ASN1_SEQUENCE_END(X509_SIG)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_SIG)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_spki.c openssl-1.0.0q/crypto/asn1/x_spki.c
--- openssl-1.0.0q.orig/crypto/asn1/x_spki.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_spki.c	2017-04-25 16:23:40.023525892 +0200
@@ -60,22 +60,29 @@
   * wrote it.  It is under my Copyright with his permission
   */
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(NETSCAPE_SPKAC) = {
-	ASN1_SIMPLE(NETSCAPE_SPKAC, pubkey, X509_PUBKEY),
+ASN1_SEQUENCE(NETSCAPE_SPKAC)
+	ASN1_SIMPLE(NETSCAPE_SPKAC, pubkey, X509_PUBKEY)
 	ASN1_SIMPLE(NETSCAPE_SPKAC, challenge, ASN1_IA5STRING)
-} ASN1_SEQUENCE_END(NETSCAPE_SPKAC)
+ASN1_SEQUENCE_END(NETSCAPE_SPKAC)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(NETSCAPE_SPKAC)
+#endif
 
-ASN1_SEQUENCE(NETSCAPE_SPKI) = {
-	ASN1_SIMPLE(NETSCAPE_SPKI, spkac, NETSCAPE_SPKAC),
-	ASN1_SIMPLE(NETSCAPE_SPKI, sig_algor, X509_ALGOR),
+ASN1_SEQUENCE(NETSCAPE_SPKI)
+	ASN1_SIMPLE(NETSCAPE_SPKI, spkac, NETSCAPE_SPKAC)
+	ASN1_SIMPLE(NETSCAPE_SPKI, sig_algor, X509_ALGOR)
 	ASN1_SIMPLE(NETSCAPE_SPKI, signature, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END(NETSCAPE_SPKI)
+ASN1_SEQUENCE_END(NETSCAPE_SPKI)
 
-IMPLEMENT_ASN1_FUNCTIONS(NETSCAPE_SPKI)
+IMPLEMENT_ASN1_FUNCTIONS1(NETSCAPE_SPKI)
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_val.c openssl-1.0.0q/crypto/asn1/x_val.c
--- openssl-1.0.0q.orig/crypto/asn1/x_val.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_val.c	2017-04-25 16:23:40.024525740 +0200
@@ -56,14 +56,19 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(X509_VAL) = {
-	ASN1_SIMPLE(X509_VAL, notBefore, ASN1_TIME),
+ASN1_SEQUENCE(X509_VAL)
+	ASN1_SIMPLE(X509_VAL, notBefore, ASN1_TIME)
 	ASN1_SIMPLE(X509_VAL, notAfter, ASN1_TIME)
-} ASN1_SEQUENCE_END(X509_VAL)
+ASN1_SEQUENCE_END(X509_VAL)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(X509_VAL)
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_x509.c openssl-1.0.0q/crypto/asn1/x_x509.c
--- openssl-1.0.0q.orig/crypto/asn1/x_x509.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_x509.c	2017-04-25 16:23:40.025525587 +0200
@@ -56,27 +56,32 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE_enc(X509_CINF, enc, 0) = {
-	ASN1_EXP_OPT(X509_CINF, version, ASN1_INTEGER, 0),
-	ASN1_SIMPLE(X509_CINF, serialNumber, ASN1_INTEGER),
-	ASN1_SIMPLE(X509_CINF, signature, X509_ALGOR),
-	ASN1_SIMPLE(X509_CINF, issuer, X509_NAME),
-	ASN1_SIMPLE(X509_CINF, validity, X509_VAL),
-	ASN1_SIMPLE(X509_CINF, subject, X509_NAME),
-	ASN1_SIMPLE(X509_CINF, key, X509_PUBKEY),
-	ASN1_IMP_OPT(X509_CINF, issuerUID, ASN1_BIT_STRING, 1),
-	ASN1_IMP_OPT(X509_CINF, subjectUID, ASN1_BIT_STRING, 2),
+ASN1_SEQUENCE_enc(X509_CINF, enc, 0)
+	ASN1_EXP_OPT(X509_CINF, version, ASN1_INTEGER, 0)
+	ASN1_SIMPLE(X509_CINF, serialNumber, ASN1_INTEGER)
+	ASN1_SIMPLE(X509_CINF, signature, X509_ALGOR)
+	ASN1_SIMPLE(X509_CINF, issuer, X509_NAME)
+	ASN1_SIMPLE(X509_CINF, validity, X509_VAL)
+	ASN1_SIMPLE(X509_CINF, subject, X509_NAME)
+	ASN1_SIMPLE(X509_CINF, key, X509_PUBKEY)
+	ASN1_IMP_OPT(X509_CINF, issuerUID, ASN1_BIT_STRING, 1)
+	ASN1_IMP_OPT(X509_CINF, subjectUID, ASN1_BIT_STRING, 2)
 	ASN1_EXP_SEQUENCE_OF_OPT(X509_CINF, extensions, X509_EXTENSION, 3)
-} ASN1_SEQUENCE_END_enc(X509_CINF, X509_CINF)
+ASN1_SEQUENCE_END_enc(X509_CINF, X509_CINF)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(X509_CINF)
+#endif
 /* X509 top level structure needs a bit of customisation */
 
 extern void policy_cache_free(X509_POLICY_CACHE *cache);
@@ -115,7 +120,9 @@
 		ASN1_OCTET_STRING_free(ret->skid);
 		AUTHORITY_KEYID_free(ret->akid);
 		CRL_DIST_POINTS_free(ret->crldp);
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 		policy_cache_free(ret->policy_cache);
+#endif
 		GENERAL_NAMES_free(ret->altname);
 		NAME_CONSTRAINTS_free(ret->nc);
 #ifndef OPENSSL_NO_RFC3779
@@ -132,15 +139,16 @@
 
 }
 
-ASN1_SEQUENCE_ref(X509, x509_cb, CRYPTO_LOCK_X509) = {
-	ASN1_SIMPLE(X509, cert_info, X509_CINF),
-	ASN1_SIMPLE(X509, sig_alg, X509_ALGOR),
+ASN1_SEQUENCE_ref(X509, x509_cb, CRYPTO_LOCK_X509)
+	ASN1_SIMPLE(X509, cert_info, X509_CINF)
+	ASN1_SIMPLE(X509, sig_alg, X509_ALGOR)
 	ASN1_SIMPLE(X509, signature, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END_ref(X509, X509)
+ASN1_SEQUENCE_END_ref(X509, X509)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509)
 IMPLEMENT_ASN1_DUP_FUNCTION(X509)
 
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_X509_EX_DATA
 int X509_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func,
 	     CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func)
         {
@@ -157,6 +165,7 @@
 	{
 	return(CRYPTO_get_ex_data(&r->ex_data,idx));
 	}
+#endif
 
 /* X509_AUX ASN1 routines. X509_AUX is the name given to
  * a certificate with extra info tagged on the end. Since these
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_x509a.c openssl-1.0.0q/crypto/asn1/x_x509a.c
--- openssl-1.0.0q.orig/crypto/asn1/x_x509a.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_x509a.c	2017-04-25 16:23:40.026526832 +0200
@@ -56,11 +56,14 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* X509_CERT_AUX routines. These are used to encode additional
  * user modifiable data about a certificate. This data is
@@ -69,18 +72,21 @@
  * will simply ignore the extra data. 
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 static X509_CERT_AUX *aux_get(X509 *x);
+#endif
 
-ASN1_SEQUENCE(X509_CERT_AUX) = {
-	ASN1_SEQUENCE_OF_OPT(X509_CERT_AUX, trust, ASN1_OBJECT),
-	ASN1_IMP_SEQUENCE_OF_OPT(X509_CERT_AUX, reject, ASN1_OBJECT, 0),
-	ASN1_OPT(X509_CERT_AUX, alias, ASN1_UTF8STRING),
-	ASN1_OPT(X509_CERT_AUX, keyid, ASN1_OCTET_STRING),
+ASN1_SEQUENCE(X509_CERT_AUX)
+	ASN1_SEQUENCE_OF_OPT(X509_CERT_AUX, trust, ASN1_OBJECT)
+	ASN1_IMP_SEQUENCE_OF_OPT(X509_CERT_AUX, reject, ASN1_OBJECT, 0)
+	ASN1_OPT(X509_CERT_AUX, alias, ASN1_UTF8STRING)
+	ASN1_OPT(X509_CERT_AUX, keyid, ASN1_OCTET_STRING)
 	ASN1_IMP_SEQUENCE_OF_OPT(X509_CERT_AUX, other, X509_ALGOR, 1)
-} ASN1_SEQUENCE_END(X509_CERT_AUX)
+ASN1_SEQUENCE_END(X509_CERT_AUX)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_CERT_AUX)
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 static X509_CERT_AUX *aux_get(X509 *x)
 {
 	if(!x) return NULL;
@@ -133,7 +139,9 @@
 	if(len) *len = x->aux->keyid->length;
 	return x->aux->keyid->data;
 }
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 int X509_add1_trust_object(X509 *x, ASN1_OBJECT *obj)
 {
 	X509_CERT_AUX *aux;
@@ -172,9 +180,10 @@
 	}
 }
 
-ASN1_SEQUENCE(X509_CERT_PAIR) = {
-	ASN1_EXP_OPT(X509_CERT_PAIR, forward, X509, 0),
+ASN1_SEQUENCE(X509_CERT_PAIR)
+	ASN1_EXP_OPT(X509_CERT_PAIR, forward, X509, 0)
 	ASN1_EXP_OPT(X509_CERT_PAIR, reverse, X509, 1)
-} ASN1_SEQUENCE_END(X509_CERT_PAIR)
+ASN1_SEQUENCE_END(X509_CERT_PAIR)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_CERT_PAIR)
+#endif /* OPERA_SMALL_VERSION */
diff -Naur openssl-1.0.0q.orig/crypto/bf/.gitignore openssl-1.0.0q/crypto/bf/.gitignore
--- openssl-1.0.0q.orig/crypto/bf/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/.gitignore	2017-04-25 16:23:40.027527518 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/bf/bf_cfb64.c openssl-1.0.0q/crypto/bf/bf_cfb64.c
--- openssl-1.0.0q.orig/crypto/bf/bf_cfb64.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bf_cfb64.c	2017-04-25 16:23:40.027527518 +0200
@@ -56,7 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_BF
 #include <openssl/blowfish.h>
+
+#ifdef OPENSSL_USE_CFB_CIPHERS
+
 #include "bf_locl.h"
 
 /* The input and output encrypted as though 64bit cfb mode is being
@@ -119,3 +123,6 @@
 	*num=n;
 	}
 
+#endif
+
+#endif // OPENSSL_NO_BF
diff -Naur openssl-1.0.0q.orig/crypto/bf/bf_ecb.c openssl-1.0.0q/crypto/bf/bf_ecb.c
--- openssl-1.0.0q.orig/crypto/bf/bf_ecb.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bf_ecb.c	2017-04-25 16:23:40.028527365 +0200
@@ -65,7 +65,9 @@
  * CAMBRIDGE SECURITY WORKSHOP, CAMBRIDGE, U.K., DECEMBER 9-11, 1993)
  */
 
-const char BF_version[]="Blowfish" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char BF_version[]="Blowfish" OPENSSL_VERSION_PTEXT;/* ARRAY OK 2007-02-27 haavardm */ 
+#endif
 
 const char *BF_options(void)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/bf/bf_enc.c openssl-1.0.0q/crypto/bf/bf_enc.c
--- openssl-1.0.0q.orig/crypto/bf/bf_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bf_enc.c	2017-04-25 16:23:40.029526934 +0200
@@ -56,6 +56,8 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_BF
+
 #include <openssl/blowfish.h>
 #include "bf_locl.h"
 
@@ -304,3 +306,5 @@
 	}
 
 #endif
+
+#endif // OPENSSL_NO_BF
diff -Naur openssl-1.0.0q.orig/crypto/bf/bf_opts.c openssl-1.0.0q/crypto/bf/bf_opts.c
--- openssl-1.0.0q.orig/crypto/bf/bf_opts.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bf_opts.c	2017-04-25 16:23:40.030526782 +0200
@@ -63,7 +63,9 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD_IO
@@ -74,10 +76,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -95,7 +101,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/bf/bf_skey.c openssl-1.0.0q/crypto/bf/bf_skey.c
--- openssl-1.0.0q.orig/crypto/bf/bf_skey.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bf_skey.c	2017-04-25 16:23:40.031527188 +0200
@@ -56,8 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_BF
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/blowfish.h>
 #include "bf_locl.h"
 #include "bf_pi.h"
@@ -69,7 +75,7 @@
 	const unsigned char *d,*end;
 
 
-	memcpy(key,&bf_init,sizeof(BF_KEY));
+	op_memcpy(key,&bf_init,sizeof(BF_KEY));
 	p=key->P;
 
 	if (len > ((BF_ROUNDS+2)*4)) len=(BF_ROUNDS+2)*4;
@@ -114,3 +120,4 @@
 		}
 	}
 
+#endif // OPENSSL_NO_BF
diff -Naur openssl-1.0.0q.orig/crypto/bf/bfs.cpp openssl-1.0.0q/crypto/bf/bfs.cpp
--- openssl-1.0.0q.orig/crypto/bf/bfs.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bfs.cpp	2017-04-25 16:23:40.031527188 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/blowfish.h>
 
 void main(int argc,char *argv[])
diff -Naur openssl-1.0.0q.orig/crypto/bf/bfspeed.c openssl-1.0.0q/crypto/bf/bfspeed.c
--- openssl-1.0.0q.orig/crypto/bf/bfspeed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bf/bfspeed.c	2017-04-25 16:23:40.032527315 +0200
@@ -63,7 +63,9 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD_IO
@@ -74,10 +76,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -95,7 +101,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
